clear all;
clc;


% Task 1: Geometric Interpretation
disp('Geometric Interpretation')

q1 =inline ('acos(-(x(1)^2+x(2)^2 -l1^2 -l2^2)/(2*l1*l2))','l1','l2','x');
q2 =inline ('acos(-(l2^2-x(1)^2-x(2)^2-l1^2)/(2*l1*sqrt(x(1)^2+x(2)^2)))','l1','l2','x');

disp('Input')
% 2D input coordinates
x1 = [10,10]
x2 = [25,10]
x3 = [5,20]
l1 = 20
l2 = 10

disp('Joint angles')
% corresponding joint angles q1 and q2 in degrees
q_1 = [radtodeg(q1(l1,l2,x1)) radtodeg(q2(l1,l2,x1))]
q_2 = [radtodeg(q1(l1,l2,x2)) radtodeg(q2(l1,l2,x2))]
q_3 = [radtodeg(q1(l1,l2,x3)) radtodeg(q2(l1,l2,x3))]


% Task 2: Principal Component Analysis
disp('PCA')
% Input matrix 
disp('data');
 X = [3 0 1; -4 1 2; -6 0 2]

% 1) Calculate mean and variance 
 x_mean = mean(X,2);
 x_var = var(X);
 
% 2) Calculate covariance matrix
 C = cov(X);

% 3) Calculate eigenvalues and eigenvectors
[V D] = eig(C);

% 4) Reorganized Basis-Matrix with two entries corresponding to
% the 2 greatest eigenvalues 
V_2D = [V(:,end) V(:,end-1)];

% 5) Map datapoints to 2D space
disp('projected points 2D')
x_proj_1 = V_2D'*((X(:,1))-x_mean)
x_proj_2 = V_2D'*((X(:,2))-x_mean)
x_proj_3 = V_2D'*((X(:,3))-x_mean)



